<apex:page standardController="Equipment_Transfer_Form__c" extensions="EquipmentTransferFormControllerX" sidebar="false" title="Equipment Transfer Request Edit" lightningStylesheets="true">
    
<!-- MZ 27-Feb-17 Added reference to Well Event-->    

<apex:sectionHeader title="Equipment Transfer Request" subTitle="{!form.Name}"/>
<script language='javascript'>
function setFocusOnLoad(){ /*NOOP*/ }

function display(myimage) 
{
	//KK 6/Apr/2015: change the size to try to fit the image
     html = "<HTML><HEAD><TITLE>Photo</TITLE>" +
      "</HEAD><BODY LEFTMARGIN=0 " 
      + "MARGINWIDTH=0 TOPMARGIN=0 MARGINHEIGHT=0><CENTER>" 
      + "<IMG SRC='" + myimage + "' BORDER=0 NAME=image " 
      + "onload='window.resizeTo(window.outerWidth-window.innerWidth+document.image.width+10,window.outerHeight-window.innerHeight+document.image.height+10);'>"
      + "</CENTER>" 
      + "</BODY></HTML>";
     window.opener=self;
	//KK 6/Apr/2015: add resizable and add scrollbars and add toolbar
     popup = window.open('','image', 'toolbar=1, location=0, directories=0, status=no, menubar=0, resizable=1, scrollbars=1, copyhistory=0');
     popup.document.open();
     popup.document.write(html);
     popup.document.focus();
     popup.document.close(); 
 }; 
</SCRIPT>  

<apex:form >
    <apex:outputPanel id="jspanel">
        <script type="text/javascript">

            // ----------------------------------------------------------------------------
            // The Equipment lookup popup
            var newWindows = null;
            
            // ----------------------------------------------------------------------------
            // Open the Equipment Search popup with appropriate parameters
            function openEquipmentMulilineItemPage() {
            
              // URL of the EquipmentMultilineItem  page
              // url should be dynamic - url parameters should include location if they have a value or facility if they have a value or well event if they have value
             
              var fromLoc = '{!form.From_Location__c}';
              var toLoc = '{!form.To_Location__c}';
              var fromFac = '{!form.From_Facility__c}';
              var toFac = '{!form.To_Facility__c}';
              var fromEvent = '{!form.From_Well_Event__c}';
              var toEvent = '{!form.To_Well_Event__c}';
              var fromSys = '{!form.From_System__c}';
              var toSys = '{!form.To_System__c}';
              var fromSubSys = '{!form.From_Sub_System__c}';
              var toSubSys = '{!form.To_Sub_System__c}';
              var fromFEL = '{!form.From_Functional_Equipment_Level__c}';
              var toFEL = '{!form.To_Functional_Equipment_Level__c}';
              var fromYard = '{!form.From_Yard__c}';
              var toYard = '{!form.To_Yard__c}';

              var url = "{!URLFOR($Site.Prefix + '/apex/EquipmentTransferItemSelection', null, [equipId=equipIds], false)}";

              if((fromLoc != null && fromLoc != undefined) || (toLoc != null && toLoc != undefined))
              {
              	url += '&fromLocId={!form.From_Location__c}&toLocId={!form.To_Location__c}';		
              }
              if((fromFac != null && fromFac != undefined) || (toFac != null && toLoc != undefined))
              {
              	url += '&fromFacId={!form.From_Facility__c}&toFacId={!form.To_Facility__c}';
              }
              if((fromEvent != null && fromEvent != undefined) || (toEvent != null && toEvent != undefined))
              {
              	url += '&fromEventId={!form.From_Well_Event__c}&toEventId={!form.To_Well_Event__c}';
              }
              if((fromSys != null && fromSys != undefined) || (toSys != null && toSys != undefined))
              {
              	url += '&fromSystemId={!form.From_System__c}&toSystemId={!form.To_System__c}';
              }
              if((fromSubSys != null && fromSubSys != undefined) || (toSubSys != null && toSubSys != undefined))
              {
              	url += '&fromSubSysId={!form.From_Sub_System__c}&toSubSysId={!form.To_Sub_System__c}';
              }
               if((fromYard != null && fromYard != undefined) || (toYard != null && toYard != undefined))
              {
                url += '&fromYardId={!form.From_Yard__c}&toYardId={!form.To_Yard__c}';
              }
               if((fromFEL != null && fromFEL != undefined) || (toFEL != null && toFEL != undefined))
              {
                url += '&fromFELId={!form.From_Functional_Equipment_Level__c}&toFELId={!form.To_Functional_Equipment_Level__c}';
              }
              
              // Open the popup
              newWindow = window.open(url, 'Popup', 
                                      'resizable=no,scrollbars=yes,toolbar=no,status=no');
              if (window.focus) {
                newWindow.focus();
              }
              
              return false;
            
            }
        
        
        </script>  
    </apex:outputPanel>
    
    <apex:pageMessage severity="Info"
        strength="3"
        summary="{!$Label.Equipment_Transfer_New_Button_Info_Message}"
        escape="false"
        rendered="{!isEmptyFloc}">
    </apex:pageMessage>
    
   <apex:pageMessages />
    <apex:actionRegion >
        <apex:actionFunction name="reloadEquipmentTable" status="myStatus" action="{!addToEquipmentList}" rerender="equipmentTable, jspanel" immediate="true">
            <apex:param name="equipIds" assignTo="{!toSelectIds}" value=""/>
        </apex:actionFunction>
    </apex:actionRegion>
    <apex:pageBlock title="Equipment Transfer Request Edit" rendered="{!!isEmptyFloc}">
          <style>
            body .bPageBlock .pbBody .subBlock .pbSubheader{
                background-color:#a5d5e0;
            }
            body .bPageBlock .pbBody .subBlock .pbSubheader h3{
                color:#000;
            }
        </style>  
          <apex:pageBlockSection title="List of Selected Equipment" columns="1">
                <apex:outputPanel style="width:100%; text-align:center" layout="block" rendered="{!isEditable}">
                    <apex:actionRegion >
                        <apex:commandButton value="Add Equipment" immediate="true" id="btnAddEquipment" onclick="openEquipmentMulilineItemPage(); return false;" />
                    </apex:actionRegion>
                </apex:outputPanel>  
            
                <apex:outputPanel id="equipmentTable">
                    <apex:pageBlockTable value="{!equipmentList}" var="e" >
                        <apex:column rendered="{!isEditable}">
                            <apex:actionRegion >
                                <apex:commandLink value="Del" action="{!removeFromEquipmentList}" reRender="equipmentTable, jspanel" immediate="true">
                                    <!-- this param is how we send an argument to the controller, so it knows which row we clicked 'remove' on -->
                                    <apex:param value="{!e.equipment.Equipment__c}" assignTo="{!toUnselect}" name="toUnselect"/>
                                </apex:commandLink>
                            </apex:actionRegion>
                        </apex:column>
                        <apex:column headerValue="{!$ObjectType.Equipment__c.Fields.Equipment_Number__c.Label}" value="{!e.equipment.Equipment__c}" />
                            <apex:column >
                          <apex:facet name="header">Location of Equipment</apex:facet>
                          <apex:outputField value="{!e.equipment.Equipment__r.Location__c}" rendered="{!e.equipment.Equipment__r.Location__c != null}"/>
                          <apex:outputField value="{!e.equipment.Equipment__r.Facility__c}" rendered="{!e.equipment.Equipment__r.Facility__c != null}"/>
                          <apex:outputField value="{!e.equipment.Equipment__r.Well_Event__c}" rendered="{!e.equipment.Equipment__r.Well_Event__c != null}"/>
                          <apex:outputField value="{!e.equipment.Equipment__r.System__c}" rendered="{!e.equipment.Equipment__r.System__c != null}"/>
                          <apex:outputField value="{!e.equipment.Equipment__r.Sub_System__c}" rendered="{!e.equipment.Equipment__r.Sub_System__c != null}"/>
                          <apex:outputField value="{!e.equipment.Equipment__r.Functional_Equipment_Level__c}" rendered="{!e.equipment.Equipment__r.Functional_Equipment_Level__c != null}"/>
                          <apex:outputField value="{!e.equipment.Equipment__r.Yard__c}" rendered="{!e.equipment.Equipment__r.Yard__c != null}"/>                                                         
                        </apex:column>
                        <apex:column headerValue="{!$ObjectType.Equipment__c.Fields.Description_of_Equipment__c.Label}" value="{!e.equipment.Equipment__r.Description_of_Equipment__c}"/>
                        <apex:column headerValue="{!$ObjectType.Equipment__c.Fields.Manufacturer__c.Label}" value="{!e.equipment.Equipment__r.Manufacturer__c}"/>
                        <apex:column headerValue="{!$ObjectType.Equipment__c.Fields.Model_Number__c.Label}" value="{!e.equipment.Equipment__r.Model_Number__c}"/>
                        <apex:column headerValue="{!$ObjectType.Equipment__c.Fields.Manufacturer_Serial_No__c.Label}" value="{!e.equipment.Equipment__r.Manufacturer_Serial_No__c}"/>
                        <apex:column headerValue="{!$ObjectType.Equipment__c.Fields.Tag_Number__c.Label}" value="{!e.equipment.Equipment__r.Tag_Number__c}"/>
                        <!-- Tag Colour  -->
                        <apex:column headerValue="{!$ObjectType.Equipment_Transfer_Item__c.Fields.Tag_Colour__c.Label}">
                            <!-- Cannot use required="true" because view state limit error when missing required field and big file 
                    + The first thing that happens in a postback request is that the view state is decoded.-->
                            
                                
                            <apex:outputPanel rendered="{!isEditable}">
                                <div class="requiredInput">
                                    <div class="requiredBlock"></div>     
                                    <apex:inputField value="{!e.equipment.Tag_Colour__c}" />
                                </div>
                            </apex:outputPanel>
                            <apex:outputField value="{!e.equipment.Tag_Colour__c}" rendered="{!isClosed}"/>
                        </apex:column> 
                        <apex:column headerValue="Attachment">
                            <apex:actionRegion >
                            <apex:inputFile value="{!e.photo.body}" filename="{!e.photo.Name}" contentType="{!e.photo.ContentType}"  rendered="{!(e.photo.Id == null && e.photoFile.ContentDocumentId == null && isEditable)}"/>
                            </apex:actionRegion>
                            <apex:outputPanel rendered="{!e.photo.Id != null || e.photoFile != null}">
                                <apex:image height="150px" width="150px" url="/servlet/servlet.FileDownload?file={!e.photo.Id}" rendered="{!If(CONTAINS(e.photo.ContentType, 'image'), true, false) && e.photoFile.ContentDocumentId == null}" onclick="javascript:display('/servlet/servlet.FileDownload?file={!e.photo.Id}')"/>
                                <apex:outputLink value="/servlet/servlet.FileDownload?file={!e.photo.Id}" target="_blank" rendered="{!If(CONTAINS(e.photo.ContentType, 'image'), false, true) && e.photoFile.ContentDocumentId == null}">{!e.photo.Name}</apex:outputLink>
                                <apex:outputLink value="/{!e.photoFile.ContentDocumentId}" target="_blank" rendered="{!e.photoFile.ContentDocumentId != null}">{!e.photoFile.ContentDocument.Title}</apex:outputLink>
                                <apex:commandLink action="{!DeletePhoto}" rendered="{!isEditable}" immediate="true" onclick="return confirm('Are you sure?');">
                                    <apex:image value="/img/func_icons/remove12_on.gif" />
                                    <apex:param name="equipId" value="{!e.equipment.Equipment__c}" />
                                </apex:commandLink>
                            </apex:outputPanel>
                        </apex:column>
                    </apex:pageBlockTable>
                    <apex:outputText value="No records to display" styleClass="x-grid-empty" rendered="{!OR(equipmentList = null, equipmentList.size = 0)}" />
                </apex:outputPanel>
          </apex:pageBlockSection>
          <apex:pageBlockSection title="Information">
             <!-- Reason for Transfer -->
             <!-- Cannot use required="true" because view state limit error when missing required field and big file 
                    + The first thing that happens in a postback request is that the view state is decoded.-->
             <apex:pageBlockSectionItem rendered="{!isEditable}">
                <apex:outputLabel value="{!$ObjectType.Equipment_Transfer_Form__c.Fields.Reason_for_Transfer_Additional_Details__c.Label}" /> 
                <apex:outputPanel >
                    <div class="requiredInput">
                        <div class="requiredBlock"></div>     
                        <apex:inputField value="{!form.Reason_for_Transfer_Additional_Details__c}" />
                    </div>
                </apex:outputPanel>
             </apex:pageBlockSectionItem>
            <apex:outputField value="{!form.Reason_for_Transfer_Additional_Details__c}" rendered="{!isClosed}"/>

             <!-- Request Status -->
             <apex:outputField value="{!form.Status__c}" /> 
             
             <!-- Date of Physical Transfer -->
             <!-- Cannot use required="true" because view state limit error when missing required field and big file 
                    + The first thing that happens in a postback request is that the view state is decoded.-->
             <apex:pageBlockSectionItem >
                <apex:outputLabel value="{!$ObjectType.Equipment_Transfer_Form__c.Fields.Date_of_Physical_Transfer__c.Label}" /> 
                <apex:outputPanel >
                    <div class="requiredInput">
                        <div class="requiredBlock"></div>     
                        <apex:inputField value="{!form.Date_of_Physical_Transfer__c}" rendered="{!isEditable}" />
                    </div>
                    <apex:outputField value="{!form.Date_of_Physical_Transfer__c}" rendered="{!isClosed}"/>
                </apex:outputPanel>
             </apex:pageBlockSectionItem>

             <!-- Maintenance WO -->
             <apex:inputField value="{!form.Maintenance_Work_Order__c}" rendered="{!isEditable}"/>
             <apex:outputField value="{!form.Maintenance_Work_Order__c}" rendered="{!isClosed}"/>
             
             <!-- Authorized by -->
             <!-- Cannot use required="true" because view state limit error when missing required field and big file 
                    + The first thing that happens in a postback request is that the view state is decoded.-->
             <apex:pageBlockSectionItem rendered="{!isEditable}">
                <apex:outputLabel value="{!$ObjectType.Equipment_Transfer_Form__c.Fields.Authorized_By__c.Label}" />
                <apex:outputPanel >
                    <div class="requiredInput">
                        <div class="requiredBlock"></div>
                        <apex:inputField value="{!form.Authorized_By__c}" />
                    </div>
                </apex:outputPanel>
             </apex:pageBlockSectionItem>
              <apex:outputField value="{!form.Authorized_By__c}" rendered="{!isClosed}"/>

             <!-- Shipped Via -->
             <apex:inputField value="{!form.Shipped_Via__c}" rendered="{!isEditable}"/>
             <apex:outputField value="{!form.Shipped_Via__c}" rendered="{!isClosed}"/>

             <!--Safety Critical Equipment Checkbox-->
              <apex:pageBlockSectionItem rendered="{!isEditable}">
                 <apex:outputLabel value="{!$ObjectType.Equipment_Transfer_Form__c.Fields.Safety_Critical_Equipment__c.Label}" />
                 <apex:inputCheckbox value="{!form.Safety_Critical_Equipment__c}" />
             </apex:pageBlockSectionItem>
              <apex:outputField value="{!form.Safety_Critical_Equipment__c}" rendered="{!isClosed}"/>


             <!-- Waybill No -->
             <apex:inputField value="{!form.Waybill_No__c}" rendered="{!isEditable}"/>
             <apex:outputField value="{!form.Waybill_No__c}" rendered="{!isClosed}"/>

              <!--Regulatory Equipment Checkbox-->
             <apex:pageBlockSectionItem rendered="{!isEditable}">
                 <apex:outputLabel value="{!$ObjectType.Equipment_Transfer_Form__c.Fields.Regulatory_Equipment__c.Label}" />
                 <apex:inputCheckbox value="{!form.Regulatory_Equipment__c}" />
             </apex:pageBlockSectionItem>
              <apex:outputField value="{!form.Regulatory_Equipment__c}" rendered="{!isClosed}"/>

             <!-- Charge No. -->
             <apex:inputField value="{!form.Charge_No__c}" rendered="{!isEditable}"/>
             <apex:outputField value="{!form.Charge_No__c}" rendered="{!isClosed}"/>
            <!--Expiration Date-->
             <apex:inputField value="{!form.Expiration_Date__c}" rendered="{!isEditable && isUserAdmin}"/>
              <apex:outputField value="{!form.Expiration_Date__c}" rendered="{!isClosed || !isUserAdmin}" />
            <apex:pageBlockSectionItem />

<!-- FROM Section For Location -->             
             <apex:outputPanel styleClass="subBlock" layout="block" rendered="{!form.From_Location__c != null}">   
                 <apex:pageBlockSection columns="1" title="FROM (Source)" collapsible="false">
                    <!-- From Location -->
                    <!-- Cannot use required="true" because view state limit error when missing required field and big file 
                    + The first thing that happens in a postback request is that the view state is decoded.-->
                    
                    <apex:outputField value="{!form.From_Location__c}"/>
                 </apex:pageBlockSection>
                 
             </apex:outputPanel>
             
<!--  FROM Section For Well Event -->

             <apex:outputPanel styleClass="subBlock" layout="block" rendered="{!form.From_Well_Event__c != null}">   
                 <apex:pageBlockSection columns="1" title="FROM (Source)" collapsible="false">
                    
                    <apex:outputField value="{!form.From_Well_Event__c}"/>
                 </apex:pageBlockSection>
                 
             </apex:outputPanel>
             
<!--  FROM Section For System -->

             <apex:outputPanel styleClass="subBlock" layout="block" rendered="{!form.From_System__c != null}">   
                 <apex:pageBlockSection columns="1" title="FROM (Source)" collapsible="false">
                    
                    <apex:outputField value="{!form.From_System__c}"/>
                 </apex:pageBlockSection>
                 
             </apex:outputPanel>             

<!--  FROM Section For Sub-System -->

             <apex:outputPanel styleClass="subBlock" layout="block" rendered="{!form.From_Sub_System__c != null}">   
                 <apex:pageBlockSection columns="1" title="FROM (Source)" collapsible="false">
                     
                    <apex:outputField value="{!form.From_Sub_System__c}"/>
                 </apex:pageBlockSection>
                 
             </apex:outputPanel>             

<!--  FROM Section For FEL -->

             <apex:outputPanel styleClass="subBlock" layout="block" rendered="{!form.From_Functional_Equipment_Level__c != null}">   
                 <apex:pageBlockSection columns="1" title="FROM (Source)" collapsible="false">
                    
                    <apex:outputField value="{!form.From_Functional_Equipment_Level__c}"/>
                 </apex:pageBlockSection>
                 
             </apex:outputPanel>      

<!--  FROM Section For Yard -->

             <apex:outputPanel styleClass="subBlock" layout="block" rendered="{!form.From_Yard__c != null}">   
                 <apex:pageBlockSection columns="1" title="FROM (Source)" collapsible="false">
                    
                    <apex:outputField value="{!form.From_Yard__c}"/>
                 </apex:pageBlockSection>
                 
             </apex:outputPanel>       
              
<!--  FROM Section For Facility -->

             <apex:outputPanel styleClass="subBlock" layout="block" rendered="{!form.From_Facility__c != null}">   
                 <apex:pageBlockSection columns="1" title="FROM (Source)" collapsible="false">
                    <!-- From Facility -->
                    <!-- Cannot use required="true" because view state limit error when missing required field and big file 
                    + The first thing that happens in a postback request is that the view state is decoded.-->
                    
                    <apex:outputField value="{!form.From_Facility__c}"/>
                 </apex:pageBlockSection>
                 
             </apex:outputPanel>
                          
<!-- TO Section For Location/Facility/Well Event -->             
             <apex:outputPanel styleClass="subBlock" layout="block">
                 <apex:pageBlockSection columns="1" title="TO (Destination)" collapsible="false">   
                    <!-- Cannot use required="true" because view state limit error when missing required field and big file 
                    + The first thing that happens in a postback request is that the view state is decoded.-->
                    <apex:pageBlockSectionItem rendered="{!DestInputFieldFlag}"> 
                    	<apex:actionRegion >
	                    	<apex:selectList id="chooseDestination" value="{!destinationObj}" size="1">
	                    		<apex:selectOptions value="{!DestinationObjects}"/>
	                    		<apex:actionSupport event="onchange" action="{!onSelectDestination}" rerender="destinationPanel"/>
	                    	</apex:selectList>
	                    </apex:actionRegion>
                        <apex:outputPanel id="destinationPanel">
                        	<apex:inputField value="{!form.To_Location__c}" style="width:200px" rendered="{!destinationObj == 'Location'}"/>
                        	<apex:inputField value="{!form.To_Well_Event__c}" style="width:200px" rendered="{!destinationObj == 'Well Event'}"/>
                        	<apex:inputField value="{!form.To_System__c}" style="width:200px" rendered="{!destinationObj == 'System'}"/> 
                        	<apex:inputField value="{!form.To_Sub_System__c}" style="width:200px" rendered="{!destinationObj == 'Sub-System'}"/>
                          <apex:inputField value="{!form.To_Facility__c}" style="width:200px" rendered="{!destinationObj == 'Facility'}"/> 
                          <apex:inputField value="{!form.To_Functional_Equipment_Level__c}" style="width:200px" rendered="{!destinationObj == 'Functional Equipment Level'}"/> 
                          <apex:inputField value="{!form.To_Yard__c}" style="width:200px" rendered="{!destinationObj == 'Yard'}"/> 
                        </apex:outputPanel>  
                    </apex:pageBlockSectionItem>

                    <apex:outputField value="{!form.To_Location__c}" rendered="{!LocOutputFieldFlag}"/>
                    <apex:outputField value="{!form.To_Well_Event__c}" rendered="{!EventOutputFieldFlag}"/>
                    <apex:outputField value="{!form.To_System__c}" rendered="{!SystemOutputFieldFlag}"/>
                    <apex:outputField value="{!form.To_Sub_System__c}" rendered="{!SubSystemOutputFieldFlag}"/>
                    <apex:outputField value="{!form.To_Facility__c}" rendered="{!FacOutputFieldFlag}"/>
                    <apex:outputField value="{!form.To_Functional_Equipment_Level__c}" rendered="{!FELOutputFieldFlag}"/>
                    <apex:outputField value="{!form.To_Yard__c}" rendered="{!YardOutputFieldFlag}"/>    
                 </apex:pageBlockSection> 
             </apex:outputPanel> 

          </apex:pageBlockSection>
          
          <apex:pageBlockSection title="Comments">
                <apex:inputField value="{!form.Comments__c}" style="width:250px" rendered="{!isEditable}"/>
                <apex:outputField value="{!form.Comments__c}" style="width:250px" rendered="{!isClosed}"/>



              <apex:inputField value="{!form.Reason__c}" style="width:250px" rendered="{!isEditable && isUserAdmin}"/>
              <apex:outputField value="{!form.Reason__c}" style="width:250px" rendered="{!isClosed || !isUserAdmin}"/>
        </apex:pageBlockSection>
          <apex:pageBlockButtons >
            <apex:commandButton value="{!IF(form.Id == null, 'Submit' ,'Save')}" action="{!save}" rendered="{!isEditable}"/>
            <apex:commandButton value="Cancel" action="{!cancel}" />
          </apex:pageBlockButtons>
    </apex:pageBlock>
    <!-- inputFile issue: file body always null when creating a new form with upload photo for equipments
        issue scenario: InputFile is rendered on some condition. When it is initially rendered and file is upload ok. 
            But when it is not rendered initially and I change some condition on which it is rendered then i try to attach file, File body = null
        solution: put a hidden inputfile  -->
    <apex:inputFile value="" filename="" style=" display: none" />
</apex:form>
</apex:page>